<?php

namespace Oro\Bundle\ProductBundle\Api\Processor;

use Oro\Bundle\ApiBundle\Processor\Update\UpdateContext;
use Oro\Component\ChainProcessor\ContextInterface;
use Oro\Component\ChainProcessor\ProcessorInterface;

class NormalizeProductId implements ProcessorInterface
{
    const PRODUCT_IDENTIFIER = 'sku';

    /**
     * {@inheritdoc}
     */
    public function process(ContextInterface $context)
    {
        if (!$context instanceof UpdateContext) {
            return;
        }

        $productRequestData = [self::PRODUCT_IDENTIFIER => $context->getId()];
        $context->setRequestData(array_merge($productRequestData, $context->getRequestData()));
        $context->setId(null);
    }
}
